package com.annimon.gipgame;

import java.awt.Color;
import java.awt.Graphics;

public class Background {
    
    private int yBackground, squareSize;
    private BackgroundCreator creator;
    
    public Background() {
        yBackground = 0;
        squareSize = 20;
        creator = new BackgroundCreator();
    }

    public void draw(Graphics g) {
        int[][] array = creator.getBackground();
        final int rowWidth = array[0].length;
        final int width = g.getClipBounds().width;
        final int height = g.getClipBounds().height;
        squareSize = width / rowWidth + 1;
        creator.setHeight(height / squareSize + 4);
        
        // Fill rectangles.
        for(int y = -1; y < array.length - 2; y++) {
            int[] row = array[2 + y];
            
            int top = y * squareSize + yBackground;
            if (top > height) break;
            
            for (int x = 0; x < rowWidth; x++) {
                int left = x * squareSize;
                
                g.setColor(new Color(row[x]));
                g.fillRect(left, top, squareSize, squareSize);
            }
            
        }
    }
    
    public void update(int addValue) {
        if (addValue > 200) {
            // When game is finished, speed up background.
            yBackground += 2;
            addValue /= 2;
        }
        yBackground++;
        
        // Remove last and add new row in background.
        if (yBackground >= squareSize) {
            creator.updateBackground(addValue);
            yBackground = 0;
        }
    }
}
