package com.annimon.gipgame;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.geom.Rectangle2D;

public class Bonus {
    
    private static int BONUS_SIZE = 16;
    private static int HORIZ_RANGE = 320;
    private static int HEIGHT = 480;
    
    public static void initBonusSize(int width, int height) {
        HEIGHT = height;
        
        BONUS_SIZE  = width / 30;
        HORIZ_RANGE = width - BONUS_SIZE;
    }
    
    
    private int color;
    private float speed;
    private Rectangle2D.Float bonusRect;
    
    public Bonus() {
        
        bonusRect = new Rectangle2D.Float(0, 0, BONUS_SIZE, BONUS_SIZE);
        initNewPosition();
    }

    public void draw(Graphics g) {
        g.setColor(new Color(color, true));
        g.fillRect((int) bonusRect.x, (int) bonusRect.y,
                (int) bonusRect.width, (int) bonusRect.height);
    }
    
    public void update(PlayerShip player) {
        bonusRect.y += speed;
        if (bonusRect.y > HEIGHT) {
            initNewPosition();
            player.changeScore(-1);
        } else {
            if (Util.rand(50) == 5) changeSpeed();
        }
        if (player.isCollide(bonusRect)) {
            initNewPosition();
            player.changeScore(1);
        }
    }
    
    private void initNewPosition() {
        color = Util.randomColor(128, 255) | 0xA0000000;
        changeSpeed();
        
        bonusRect.x = Util.rand(HORIZ_RANGE);
        bonusRect.y = - BONUS_SIZE - Util.rand(HEIGHT);
    }
    
    private void changeSpeed() {
        speed = Util.rand(0.2f, 4f);
    }
}
